From 60a11b8c52d47ff6d57db75de3dda35f7dc422be Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Mon, 8 Jul 2019 23:04:57 -0400
Subject: [PATCH 12/31] sufficient functionality that allows the UI for squads
 to display properly on squad joining and on squad leaving; clarification for
 SquadMemberEvent fields; QoL support functionality intergrated into SDDUM
 streams

---
 .../psforever/objects/teamwork/Squad.scala    |  12 +-
 .../SquadDetailDefinitionUpdateMessage.scala  |  91 +++-
 .../packet/game/SquadMemberEvent.scala        |  54 +--
 .../scala/services/teamwork/SquadAction.scala |  13 +
 .../services/teamwork/SquadResponse.scala     |   6 +
 .../services/teamwork/SquadService.scala      | 413 ++++++++++--------
 .../teamwork/SquadServiceMessage.scala        |   5 +-
 ...uadDetailDefinitionUpdateMessageTest.scala |  38 +-
 .../src/main/scala/WorldSessionActor.scala    | 133 +++---
 9 files changed, 456 insertions(+), 309 deletions(-)
 create mode 100644 common/src/main/scala/services/teamwork/SquadAction.scala

diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
index 21a48cb3..b5e5d81d 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
@@ -82,12 +82,12 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
     LeaderPositionIndex
   }
 
-  def Leader : String = {
-    membership.lift(leaderPositionIndex) match {
-      case Some(member) =>
-        member.Name
-      case None =>
-        ""
+  def Leader : Member = {
+    membership(leaderPositionIndex) match {
+      case member if !member.Name.equals("") =>
+        member
+      case _ =>
+        throw new Exception("can not find squad leader!")
     }
   }
 
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index ad080bcf..9bda7527 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -198,17 +198,16 @@ final case class SquadDetail(unk1 : Option[Int],
     leader_name.orElse(Some("")),
     task.orElse(Some("")),
     zone_id.orElse(Some(PlanetSideZoneID(0))),
-    unk7.orElse(Some(0)),
+    unk7.orElse(Some(4983296)), //FullSquad value
     {
       val complete = SquadPositionDetail().Complete
       Some(member_info match {
         case Some(info) =>
           //create one list that ensures all existing positions are "complete" then add a list of the missing indices
-          val fields = info.collect {
-            case SquadPositionEntry(a, Some(b)) => SquadPositionEntry(a, b.Complete)
-            case out @ SquadPositionEntry(_, None) => out
-          }
-          val indices = info.map { case SquadPositionEntry(a, _) => a }
+          val (indices, fields) = info.collect {
+            case SquadPositionEntry(a, Some(b)) => (a, SquadPositionEntry(a, b.Complete))
+            case out @ SquadPositionEntry(a, None) => (a, out)
+          }.unzip
           ((0 to 9).toSet.diff(indices.toSet).map { SquadPositionEntry(_, complete) } ++ fields).toList.sortBy(_.index)
         case None =>
           //original list
@@ -585,7 +584,6 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
     private def membersCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = {
       import shapeless.::
       (
-        //TODO you can replace this outer structure with an either Codec
         bool >>:~ { flag =>
           conditional(flag, {
             bitsOverByte.Add(4)
@@ -593,15 +591,15 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
           }) ::
             conditional(!flag, {
               bitsOverByte.Add(3)
-              uint(2) :: FullyPopulatedPositions.codec(bitsOverByte)
+              uint2 :: FullyPopulatedPositions.codec(bitsOverByte)
             })
         }
         ).exmap[SquadDetail] (
         {
           case true :: Some(_ :: member_list :: HNil) :: _ :: HNil =>
-            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(member_list.toList)))
+            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(ignoreTerminatingEntry(member_list.toList))))
           case false :: None :: Some(_ :: member_list :: HNil) :: HNil =>
-            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(member_list.toList)))
+            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(ignoreTerminatingEntry(member_list.toList))))
         },
         {
           case SquadDetail(_, _, _, _, _, _, _, _, Some(member_list)) =>
@@ -612,16 +610,54 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
               }
               .flatten
               .count(_.isEmpty) == 0) {
-              Attempt.successful(false :: None :: Some(2 :: member_list.toVector :: HNil) :: HNil)
+              Attempt.successful(false :: None :: Some(2 :: ensureTerminatingEntry(member_list).toVector :: HNil) :: HNil)
             }
             else {
-              Attempt.successful(true :: Some(4 :: member_list.toVector :: HNil) :: None :: HNil)
+              Attempt.successful(true :: Some(4 :: ensureTerminatingEntry(member_list).toVector :: HNil) :: None :: HNil)
             }
           case _ =>
             Attempt.failure(Err("failed to encode squad data for members"))
         }
       )
     }
+    //TODO while this pattern looks elegant, bitsOverByte does not accumulate properly with the either(bool, L, R); why?
+//    private def membersCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = {
+//      import shapeless.::
+//      either(bool,
+//        { //false
+//          bitsOverByte.Add(3)
+//          uint2 :: FullyPopulatedPositions.codec(bitsOverByte)
+//        },
+//        { //true
+//          bitsOverByte.Add(4)
+//          uint(3) :: vector(ItemizedPositions.codec(bitsOverByte))
+//        }
+//      ).exmap[SquadDetail] (
+//        {
+//          case Left(_ :: member_list :: HNil) =>
+//            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(ignoreTerminatingEntry(member_list.toList))))
+//          case Right(_ :: member_list :: HNil) =>
+//            Attempt.successful(SquadDetail(None, None, None, None, None, None, None, None, Some(ignoreTerminatingEntry(member_list.toList))))
+//        },
+//        {
+//          case SquadDetail(_, _, _, _, _, _, _, _, Some(member_list)) =>
+//            if(member_list
+//              .collect { case position if position.info.nonEmpty =>
+//                val info = position.info.get
+//                List(info.is_closed, info.role, info.detailed_orders, info.requirements, info.char_id, info.name)
+//              }
+//              .flatten
+//              .count(_.isEmpty) == 0) {
+//              Attempt.successful(Left(2 :: ensureTerminatingEntry(member_list).toVector :: HNil))
+//            }
+//            else {
+//              Attempt.successful(Right(4 :: ensureTerminatingEntry(member_list).toVector :: HNil))
+//            }
+//          case _ =>
+//            Attempt.failure(Err("failed to encode squad data for members"))
+//        }
+//      )
+//    }
     /**
       * A failing pattern for when the coded value is not tied to a known field pattern.
       * This pattern does not read or write any bit data.
@@ -1245,10 +1281,9 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
         }).xmap[Vector[SquadPositionEntry]] (
         {
           case _ :: _ :: linkedMembers :: HNil =>
-            unlinkFields(linkedMembers).toVector
+            ignoreTerminatingEntry(unlinkFields(linkedMembers)).toVector
         },
-        //TODO "memberList.size - 1"? the only two examples are "10" anyway
-        memberList => memberList.size - 1 :: 12 :: linkFields(memberList.reverse.toList) :: HNil
+        memberList => 10 :: 12 :: linkFields(ensureTerminatingEntry(memberList.toList).reverse) :: HNil
       )
     }
   }
@@ -1320,6 +1355,32 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
     )
   }
 
+  /**
+    * The last entry in the sequence of squad information listings should be a dummied listing with an index of 255.
+    * Ensure that this terminal entry is located at the end.
+    * @param list the listing of squad information
+    * @return the listing of squad information, with a specific final entry
+    */
+  private def ensureTerminatingEntry(list : List[SquadPositionEntry]) : List[SquadPositionEntry] = {
+    list.lastOption match {
+      case Some(SquadPositionEntry(255, _)) => list
+      case Some(_) | None => list :+ SquadPositionEntry(255, None)
+    }
+  }
+
+  /**
+    * The last entry in the sequence of squad information listings should be a dummied listing with an index of 255.
+    * Remove this terminal entry from the end of the list so as not to hassle with it.
+    * @param list the listing of squad information
+    * @return the listing of squad information, with a specific final entry truncated
+    */
+  private def ignoreTerminatingEntry(list : List[SquadPositionEntry]) : List[SquadPositionEntry] = {
+    list.lastOption match {
+      case Some(SquadPositionEntry(255, _)) => list.init
+      case Some(_) | None => list
+    }
+  }
+
   implicit val codec : Codec[SquadDetailDefinitionUpdateMessage] = {
     import shapeless.::
     import net.psforever.newcodecs.newcodecs
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala b/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala
index df8bd7b0..50dec0f6 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadMemberEvent.scala
@@ -8,10 +8,10 @@ import shapeless.{::, HNil}
 
 final case class SquadMemberEvent(unk1 : Int,
                                   unk2 : Int,
-                                  unk3 : Long,
-                                  unk4 : Int,
-                                  unk5 : Option[String],
-                                  unk6 : Option[Int],
+                                  char_id : Long,
+                                  member_position : Int,
+                                  player_name : Option[String],
+                                  zone_number : Option[Int],
                                   unk7 : Option[Long])
   extends PlanetSideGamePacket {
   type Packet = SquadMemberEvent
@@ -20,40 +20,40 @@ final case class SquadMemberEvent(unk1 : Int,
 }
 
 object SquadMemberEvent extends Marshallable[SquadMemberEvent] {
-  def apply(unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Int) : SquadMemberEvent =
-    SquadMemberEvent(unk1, unk2, unk3, unk4, None, None, None)
+  def apply(unk1 : Int, unk2 : Int, char_id : Long, member_position : Int) : SquadMemberEvent =
+    SquadMemberEvent(unk1, unk2, char_id, member_position, None, None, None)
 
-  def apply(unk2 : Int, unk3 : Long, unk4 : Int, unk5 : String, unk6 : Int, unk7 : Long) : SquadMemberEvent =
-    SquadMemberEvent(0, unk2, unk3, unk4, Some(unk5), Some(unk6), Some(unk7))
+  def apply(unk2 : Int, char_id : Long, member_position : Int, player_name : String, zone_number : Int, unk7 : Long) : SquadMemberEvent =
+    SquadMemberEvent(0, unk2, char_id, member_position, Some(player_name), Some(zone_number), Some(unk7))
 
-  def apply(unk2 : Int, unk3 : Long, unk4 : Int, unk6 : Int) : SquadMemberEvent =
-    SquadMemberEvent(3, unk2, unk3, unk4, None, Some(unk6), None)
+  def apply(unk2 : Int, char_id : Long, member_position : Int, zone_number : Int) : SquadMemberEvent =
+    SquadMemberEvent(3, unk2, char_id, member_position, None, Some(zone_number), None)
 
-  def apply(unk2 : Int, unk3 : Long, unk4 : Int, unk7 : Long) : SquadMemberEvent =
-    SquadMemberEvent(4, unk2, unk3, unk4, None, None, Some(unk7))
+  def apply(unk2 : Int, char_id : Long, member_position : Int, unk7 : Long) : SquadMemberEvent =
+    SquadMemberEvent(4, unk2, char_id, member_position, None, None, Some(unk7))
 
   implicit val codec : Codec[SquadMemberEvent] = (
-    ("unk1" | uintL(3)) >>:~ { unk1 =>
+    ("unk1" | uint(3)) >>:~ { unk1 =>
       ("unk2" | uint16L) ::
-        ("unk3" | uint32L) ::
-        ("unk4" | uintL(4)) ::
-        conditional(unk1 == 0, "unk5" | PacketHelpers.encodedWideStringAligned(1)) ::
-        conditional(unk1 == 0 || unk1 == 3, "unk6" | uint16L) ::
+        ("char_id" | uint32L) ::
+        ("member_position" | uint4) ::
+        conditional(unk1 == 0, "player_name" | PacketHelpers.encodedWideStringAligned(1)) ::
+        conditional(unk1 == 0 || unk1 == 3, "zone_number" | uint16L) ::
         conditional(unk1 == 0 || unk1 == 4, "unk7" | uint32L)
     }).exmap[SquadMemberEvent] (
     {
-      case unk1 :: unk2 :: unk3 :: unk4 :: unk5 :: unk6 :: unk7 :: HNil =>
-        Attempt.Successful(SquadMemberEvent(unk1, unk2, unk3, unk4, unk5, unk6, unk7))
+      case unk1 :: unk2 :: char_id :: member_position :: player_name :: zone_number :: unk7 :: HNil =>
+        Attempt.Successful(SquadMemberEvent(unk1, unk2, char_id, member_position, player_name, zone_number, unk7))
     },
     {
-      case data @ SquadMemberEvent(0, unk2, unk3, unk4, Some(unk5), Some(unk6), Some(unk7)) =>
-        Attempt.Successful(0 :: unk2 :: unk3 :: unk4 :: Some(unk5) :: Some(unk6) :: Some(unk7) :: HNil)
-      case data @ SquadMemberEvent(3, unk2, unk3, unk4, None, Some(unk6), None) =>
-        Attempt.Successful(3 :: unk2 :: unk3 :: unk4 :: None :: Some(unk6) :: None :: HNil)
-      case data @ SquadMemberEvent(4, unk2, unk3, unk4, None, None, Some(unk7)) =>
-        Attempt.Successful(4 :: unk2 :: unk3 :: unk4 :: None :: None :: Some(unk7) :: HNil)
-      case data @ SquadMemberEvent(unk1, unk2, unk3, unk4, None, None, None) =>
-        Attempt.Successful(unk1 :: unk2 :: unk3 :: unk4 :: None :: None :: None :: HNil)
+      case data @ SquadMemberEvent(0, unk2, char_id, member_position, Some(player_name), Some(zone_number), Some(unk7)) =>
+        Attempt.Successful(0 :: unk2 :: char_id :: member_position :: Some(player_name) :: Some(zone_number) :: Some(unk7) :: HNil)
+      case data @ SquadMemberEvent(3, unk2, char_id, member_position, None, Some(zone_number), None) =>
+        Attempt.Successful(3 :: unk2 :: char_id :: member_position :: None :: Some(zone_number) :: None :: HNil)
+      case data @ SquadMemberEvent(4, unk2, char_id, member_position, None, None, Some(unk7)) =>
+        Attempt.Successful(4 :: unk2 :: char_id :: member_position :: None :: None :: Some(unk7) :: HNil)
+      case data @ SquadMemberEvent(unk1, unk2, char_id, member_position, None, None, None) =>
+        Attempt.Successful(unk1 :: unk2 :: char_id :: member_position :: None :: None :: None :: HNil)
       case data =>
         Attempt.Failure(Err(s"SquadMemberEvent can not encode with this pattern - $data"))
     }
diff --git a/common/src/main/scala/services/teamwork/SquadAction.scala b/common/src/main/scala/services/teamwork/SquadAction.scala
new file mode 100644
index 00000000..744a4940
--- /dev/null
+++ b/common/src/main/scala/services/teamwork/SquadAction.scala
@@ -0,0 +1,13 @@
+// Copyright (c) 2019 PSForever
+package services.teamwork
+
+import net.psforever.objects.Player
+import net.psforever.packet.game._
+import net.psforever.types.SquadRequestType
+
+object SquadAction {
+  trait Action
+
+  final case class Membership(request_type : SquadRequestType.Value, unk2 : Long, unk3 : Option[Long], player_name : String, unk5 : Option[Option[String]]) extends Action
+  final case class Definition(player : Player, zone_ordinal_number : Int, guid : PlanetSideGUID, line : Int, action : SquadAction)
+}
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index 27ef6dcd..773b4067 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -1,7 +1,9 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
+import net.psforever.objects.teamwork.{Member, Squad}
 import net.psforever.packet.game._
+import net.psforever.types.SquadRequestType
 
 object SquadResponse {
   trait Response
@@ -10,5 +12,9 @@ object SquadResponse {
   final case class Update(infos : Iterable[(Int, SquadInfo)]) extends Response
   final case class Remove(infos : Iterable[Int]) extends Response
 
+  final case class Membership(request_type : SquadRequestType.Value, unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Option[Long], player_name : String, unk5 : Boolean, unk6 : Option[Option[String]]) extends Response //see SquadMembershipResponse
+  final case class Join(squad : Squad, positionsToUpdate : List[Int]) extends Response
+  final case class Leave(squad : Squad, positionsToUpdate : List[(Long, Int)]) extends Response
+
   final case class Detail(guid : PlanetSideGUID, leader : String, task : String, zone : PlanetSideZoneID, member_info : List[SquadPositionDetail]) extends Response
 }
